/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */

//Title:        Cliffhanger Adventure Gear
//Version:
//Copyright:    Copyright (c) 1997 Borland International, Inc.
//Author:       Application Methods, Inc.
//Description:  Cliffhanger Adventure Gear order entry system

package borland.reference.cliffhanger;

import java.awt.*;
import borland.jbcl.control.Message;

/**
 * CliffhangerApplication is the application class for the Cliffhanger project.
 * The static main method is implemented here, as well as other static methods
 * that are used throughout the application.
 */
public class CliffhangerApplication {
  // public variables
  public static final String MESSAGE_TITLE = "Cliffhanger";

  //Construct the application
  public CliffhangerApplication() {
    // Show the splash screen while connecting to database
    SplashFrame splash = new SplashFrame();
    splash.pack();
    showCenteredFrame(splash, true);

    // Show the Main window
    MainFrame frame = new MainFrame();
    frame.pack();
    showCenteredFrame(frame, true);

    // Hide the splash screen after the Main window appears
    splash.setVisible(false);
  }

  // Main method
  static public void main(String[] args) {
    new CliffhangerApplication();
  }

  // The following are "Global" Methods that are used through out
  // the application.

  // Method to wrap code to show a message dialog modally
  // and return the modal result of which button the user clicked.
  static public int messageDlg(String title, String message, int buttonSet) {
    Frame frame = new Frame();
    Message msgDlg = new Message( frame, title, message );
    msgDlg.setButtonSet(buttonSet);
    msgDlg.show();
    return msgDlg.getResult();
  }

  // Method to show a frame in the center of the screen.
  static public void showCenteredFrame(Frame frame, boolean usePreferredSize) {
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize;
    if (usePreferredSize)
      frameSize = frame.getPreferredSize();
    else
      frameSize = frame.getSize();

    if (frameSize.height > screenSize.height)
      frameSize.height = screenSize.height;
    if (frameSize.width > screenSize.width)
      frameSize.width = screenSize.width;
      
    frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    frame.setVisible(true);
    frame.show();
  }

}

