/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */

//Title:        Cliffhanger Order Status Tracker
//Version:
//Copyright:    Copyright (c) 1997 Borland International, Inc.
//Author:       Application Methods, Inc.
//Description:  Cliffhanger Adventure Gear Order Status Tracking Applet

package borland.reference.tracker;

import java.awt.*;
import java.awt.event.*;
import borland.jbcl.layout.*;
import borland.jbcl.control.*;
import borland.sql.dataset.*;
import borland.jbcl.dataset.*;
import java.util.*;

/**
 * OrderTrackDataModule is the DataModule class for the Applet.  It contains
 * database connectivity parameters, query parameters, and instances of the
 * QueryDataSets and ParameterRow used by the Applet.
 */
public class OrderTrackDataModule implements DataModule{
  private static OrderTrackDataModule myDM;

  Database cliffhangerDB = new Database();
  QueryDataSet qdsPOrders = new QueryDataSet();
  ParameterRow pRow = new ParameterRow();
  LabelControl amountLabel = new LabelControl();
  FieldControl amountField = new FieldControl();

  Column amountColumn = new Column();
  Column orderDateColumn = new Column();
  Column shipDateColumn = new Column();
  Column statusColumn = new Column();
  ResourceBundle res = Res.getBundle("borland.reference.tracker.Res");

  public OrderTrackDataModule() {
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception{

    // Initialize database connection
    cliffhangerDB.setConnection(new borland.sql.dataset.ConnectionDescriptor("jdbc:odbc:Cliffhanger", "SYSDBA", null, true, "sun.jdbc.odbc.JdbcOdbcDriver"));

    // Add a parameter on the field "ORDERTRACKNUM" to the row to take advantage of
    // of the parameterized query
    pRow.addColumn("ORDERTRACKNUM", borland.jbcl.util.Variant.STRING);

    amountColumn.setColumnName("AMTPAID");
    amountColumn.setCurrency(true);
    amountColumn.setDataType(borland.jbcl.util.Variant.DOUBLE);

    orderDateColumn.setColumnName("ORDERDATE");
    orderDateColumn.setDataType(borland.jbcl.util.Variant.DATE);
    orderDateColumn.setDisplayMask(res.getString("MM_dd_yyyy"));

    shipDateColumn.setColumnName("SHIPDATE");
    shipDateColumn.setDataType(borland.jbcl.util.Variant.DATE);
    shipDateColumn.setDisplayMask(res.getString("MM_dd_yyyy"));

    statusColumn.setColumnName("STATUS");
    statusColumn.setDataType(borland.jbcl.util.Variant.STRING);

    // Associate the columns with the dataset
    qdsPOrders.setColumns(new Column[] {amountColumn,
                                        orderDateColumn,
                                        shipDateColumn,
                                        statusColumn});

    /**  Define a parameterized query for use by the Applet.  The parameter "ORDERTRACKNUM"
     * will be used to match the user-input to the "ordertracknum" column in the
     * database.
     */
    qdsPOrders.setQuery(new borland.sql.dataset.QueryDescriptor(cliffhangerDB, "select * from orders where ordertracknum = :ORDERTRACKNUM", pRow, true, Load.ALL));
    qdsPOrders.setReadOnly(true);
    qdsPOrders.setEditable(false);
  }

  static public OrderTrackDataModule getDataModule() {
    if (myDM == null)
      myDM = new OrderTrackDataModule();
    return myDM;
  }

  public void dbConnect() throws DataSetException {
    // This method explicitly opens a connection to the database.
    cliffhangerDB.openConnection();
  }

  public borland.sql.dataset.QueryDataSet getOrdersDataSet() {
    return qdsPOrders;
  }

  public borland.jbcl.dataset.ParameterRow getOrderNumParameterRow() {
    return pRow;
  }

}
