/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */

//Title:        Cliffhanger Adventure Gear
//Version:
//Copyright:    Copyright (c) 1997 Borland International, Inc.
//Author:       Application Methods, Inc.
//Description:  Cliffhanger Adventure Gear order entry system

package borland.reference.cliffhanger;

import java.util.*;

/*
 ResourceBundles are the standard JDK 1.1 mechanism to allow an application to
 respond to different user locale environments. Locale dependent resources,
 such as messages, are isolated into ResourceBundles, separate from the code
 that will be universal among locales. With a single set of class files, the
 language of menus and messages of an application can change depending on
 whether it is run in the United States or Japan.

 We have adopted our own convention of prefixing the Bundle Keys with the
 initials of the corresponding java file where the string is used.
 This has the advantage that we can change a string for one frame without
 affecting other frames that might use the same string. However, it does
 end up with some redundancy. Depending on your needs you could choose to do
 it as we have, or use common Bundle Keys across the entire application.

 Because resource bundles are loaded dynamically at runtime, it is not
 possible at compile time to know which resource bundles need to be recompiled.
 Thus in order to see changes you make to this file updated in the application,
 you must explicitly recompile this file whenever you make a change to it.

 The comment '// must be consistent with DataStock.sql' indicates that if the
 string is localized here, it must also be changed in DataStock.sql.  This is
 because some of the data elements appearing in the UI (e.g., the column
 on which to perform a search) are stored as data in database tables.
*/

public class Res extends ListResourceBundle {
  static final Object[][] contents = {
// SplashFrame
     {"SF_Loading_","Loading ..."},
     // MainFrame
     {"MF_Cliffhanger_Title","Cliffhanger Order Management System"},
     {"MF_DBConnect_Failed", "Unable to connect to the cliffhanger database. Closing the application..."},
     {"MF_Error","Error"},
     {"MF_File","File"},
     {"MF_Exit","Exit"},
     {"MF_Help","Help"},
     {"MF_About","About"},
     {"MF_Orders","Orders"},
     {"MF_Customers","Customers"},
     {"MF_Products","Products"},
     {"MF_Categories","Categories"},
     {"MF_New_Order","New Order"},
     {"MF_Find_Order","Find Order"},
     {"MF_New_Customer","New Customer"},
     {"MF_Find_Customer","Find Customer"},
     {"MF_New_Product","New Product"},
     {"MF_Find_Product","Find Product"},
     {"MF_Customer_Orders","Customer Orders"},
     {"MF_Customer_Records","Customer Records"},
     {"MF_Cliffhanger_Products","Cliffhanger Products"},
     {"MF_Product_Categories","Product Categories"},
     {"MF_Exit_Cliffhanger","Exit Cliffhanger Application"},
     {"MF_OK","OK"},
     //AboutBox
     {"AB_product","Cliffhanger Adventure Gear"},
     {"AB_version","Version 1.0, 97.10.25"},
     {"AB_copyright","Copyright (c) 1997 Borland International, Inc."},
     {"AB_comments","Cliffhanger Adventure Gear order entry system"},
     {"AB_writtenby","Written by Application Methods, Inc."},
     //OrderEntryFrame
     {"OEF_Orders","Orders"},
     {"OEF_Bill_To","Bill To"},
     {"OEF_Ship_To","Ship To"},
     {"OEF_Date","Date:"},
     {"OEF_Credit_Card_No","Credit Card #"},
     {"OEF_Payment_Method","Payment Method"},
     {"OEF_Ship_Via","Ship Via"},
     {"OEF_Status","Status"},
     {"OEF_Save","Save"},
     {"OEF_Cancel","Cancel"},
     {"OEF_Close","Close"},
     {"OEF_SubTotal","SubTotal:"},
     {"OEF_Tax","Tax:"},
     {"OEF_Shipping","Shipping:"},
     {"OEF_Paid","Paid:"},
     {"OEF_Due","Due:"},
     {"OEF_Order_No","Order #:"},
     {"OEF_OrderTrack_No","OrderTrack #:"},
     {"OEF_PO_No","PO #:"},
     {"OEF_Save_as_Default","Save as Default"},
     {"OEF_Add_Item"," Add Item "},
     {"OEF_Remove_Item"," Remove Item "},
     {"OEF_Order_Item"," Order Item: "},
     {"OEF_Ship_Date","Ship Date"},
     {"OEF_Find_","Find..."},
     {"OEF_New_","New..."},
     {"OEF_Save_Pending_Changes","Save Pending Changes"},
     {"OEF_Save_pending_changes?","Save pending changes?"},
     {"OEF_Error","Error"},
     {"OEF_Find_Customer","Find Customer"},
     {"OEF_Add_Customer","Add Customer"},
     {"OEF_COD","COD"},                              // must be consistent with DataStock.sql
     // CustomerFrame
     {"CF_Customers","Customers"},
     {"CF_Name","Name:"},
     {"CF_Address_1","Address 1:"},
     {"CF_City_StateProv","City/State:"},
     {"CF_Phone","Phone:"},
     {"CF_EMail","EMail:"},
     {"CF_Fax","Fax:"},
     {"CF_Address_2","Address 2:"},
     {"CF_Postal_Code","Postal Code:"},
     {"CF_Country","Country:"},
     {"CF_First","First"},
     {"CF_MI","MI"},
     {"CF_Last","Last"},
     {"CF_View_Order"," View Order "},
     {"CF_Orders_placed_by_this","  Orders placed by this customer:"},
     {"CF_Close"," Close "},
     {"CF_New_Order"," New Order "},
     {"CF_Save_Pending_Changes","Save Pending Changes"},
     {"CF_Save_pending_changes?","Save pending changes?"},
     {"CF_Error","Error"},
     {"CF_No_order_selected","No order selected."},
     {"CF_Order_not_found","Selected order not found"},
     {"CF_No_customer_selected","No customer selected."},
     //ProductFrame
     {"PF_Products","Products"},
     {"PF_Active","Active"},
     {"PF_Name","Name:"},
     {"PF_Category","Category:"},
     {"PF_Base_Price","Base Price:"},
     {"PF_Discount_%","Discount %:"},
     {"PF_Stock_Qty","Stock Qty:"},
     {"PF_Min_Reorder_Qty","Min Reorder Qty:"},
     {"PF_Product_ID","Product ID:"},
     {"PF_Close"," Close "},
     {"PF_Save_Pending_Changes","Save Pending Changes"},
     {"PF_Save_pending_changes?","Save pending changes?"},
     {"PF_Error","Error"},
     // CategoryFrame
     {"CAF_Categories","Categories"},
     {"CAF_Close"," Close "},
     {"CAF_New_Product"," New Product "},
     {"CAF_Save_Pending_Changes","Save Pending Changes"},
     {"CAF_Save_pending_changes?","Save pending changes?"},
     {"CAF_Error","Error"},
     // FindFrame
     {"FF_Find","Find"},
     {"FF_Field","Field:"},
     {"FF_Value","Value:"},
     {"FF_Close","Close"},
     {"FF_Go_To","Go To"},
     // OrderFindFrame
     {"OFF_Find_Order","Find Order"},
     // CustomerFindFrame
     {"CFF_Find_Customer","Find Customer"},
     // ProductFindFrame
     {"PFF_Find_Product","Find Product"},
     // AddCustomerDlg
     {"ACD_Name","Name:"},
     {"ACD_Address_1","Address 1:"},
     {"ACD_CityStateProv","City/State:"},
     {"ACD_PostalCode","Postal Code:"},
     {"ACD_Phone","Phone:"},
     {"ACD_EMail","EMail:"},
     {"ACD_Address_2","Address 2:"},
     {"ACD_Country","Country:"},
     {"ACD_First","First"},
     {"ACD_MI","MI"},
     {"ACD_Last","Last"},
     {"ACD_OK","   OK   "},
     {"ACD_Cancel","Cancel"},
     // AddOrderItemDlg
     {"AOD_OK","   OK   "},
     {"AOD_Cancel","Cancel"},
     {"AOD_Product_Name","Product Name:"},
     {"AOD_Sale_Price","Sale Price:"},
     {"AOD_Extended_Price","Extended Price:"},
     {"AOD_Qty","Qty"},
     {"AOD_Product_ID","Product ID:"},
     // FindOrderCustomer
     {"FOC_OK","   OK   "},
     {"FOC_Cancel"," Cancel "},
     {"FOC_Field","Field:"},
     {"FOC_Value","Value:"},
     // DataModule1
     {"DM_Error","Error"},
     {"DM_DateDisplayMask","MM/dd/yyyy"},
     {"DM_DateEditMask","MM/dd/yyyy"},
     {"DM_Qty","Qty"},
     {"DM_Product_ID","Product ID"},
     {"DM_Name","Name"},
     {"DM_Sale_Price","Sale Price"},
     {"DM_Ext_Price","Ext Price"},
     {"DM_SubTotal","SubTotal"},
     {"DM_Order_ID","Order ID"},
     {"DM_Tax","Tax"},
     {"DM_Shipping","Shipping"},
     {"DM_Amt_Due","Amt Due"},
     {"DM_ID","ID"},
     {"DM_Is_Active","Is Active"},
     {"DM_Category","Category"},
     {"DM_Base_Price","Base Price"},
     {"DM_Discount_%","Discount %"},
     {"DM_Stock_Qty","Stock Qty"},
     {"DM_Min_ReOrder_Qty","Min ReOrder Qty"},
     {"DM_Insufficient_stock","Insufficient stock quantity"},
     {"DM_Delete_this_order","Delete this order item?"},
     {"DM_Confirm","Confirm"},
     {"DM_Delete_canceled","Delete canceled"},
     {"DM_Cannot_modify_order","Cannot modify a 'Fulfilled' order."},
     {"DM_Invalid_customer","An order must have a valid customer."},
     {"DM_Invalid_order_date","An order must have a valid order date."},
     {"DM_Invalid_status","An order must have a valid status."},
     {"DM_Invalid_paymethod","An order must have a valid payment method."},
     {"DM_Invalid_product","An order item must have a valid product."},
     {"DM_Invalid_product_quantity","An order item must have a valid product quantity."},
     {"DM_Invalid_product_name","A product must have a valid name."},
     {"DM_Invalid_product_category","A product must have a valid product category."},
     {"DM_Invalid_base_price","A product must have a valid base price value."},
     {"DM_Invalid_stock_qty","A product must have a valid stock qty value."},
     {"DM_Invalid_min_reorder_qty","A product must have a valid min reorder qty value."},
     {"DM_Invalid_category_name","A category must have a valid name."},
     {"DM_Invalid_first_name","A customer must have a valid first name."},
     {"DM_Invalid_last_name","A customer must have a valid last name."},
     {"DM_Invalid_phone","A customer must have a valid phone number."},
     {"DM_Non_Cliffcard_member","This customer is not a CliffCard member."},
     {"DM_Delete_this_order?","Delete this order?"},
     {"DM_Delete_this_product?","Delete this product?"},
     {"DM_Delete_this_customer?","Delete this customer?"},
     {"DM_Delete_this_category?","Delete this category?"},
     {"DM_Add_Order_Item","Add Order Item"},
     {"DM_Open","Open"},                // must be consistent with DataStock.sql
     {"DM_VISA","VISA"},                // must be consistent with DataStock.sql
     {"DM_UPS","UPS"},                  // must be consistent with DataStock.sql
     {"DM_Active_Wear","Active Wear"},  // must be consistent with DataStock.sql
     {"DM_Fulfilled","Fulfilled"},      // must be consistent with DataStock.sql
     {"DM_CLIFFCARD","CLIFFCARD"},      // must be consistent with DataStock.sql
     {"DM_CategoryDS_CATEGORY","Category"},
     {"DM_OrderDS_ID","ID"},
     {"DM_OrderDS_CUSTOMERID","Customer ID"},
     {"DM_OrderDS_ORDERDATE","Order Date"},
     {"DM_OrderDS_STATUS","Status"},
     {"DM_OrderDS_SHIPDATE","Ship Date"},
     {"DM_OrderDS_ORDERTRACKNUM","Order Tracking #"},
     {"DM_OrderDS_CUSTOMERPONUM","Purchase Order #"},
     {"DM_CustOrderDS_ORDERDATE","Order Date"},
     {"DM_CustOrderDS_STATUS","Status"},
     {"DM_CustOrderDS_SHIPDATE","Ship Date"},
     {"DM_CustomerDS_ID","ID"},
     {"DM_CustomerDS_FIRSTNAME","First Name"},
     {"DM_CustomerDS_MI","MI"},
     {"DM_CustomerDS_LASTNAME","Last Name"},
     {"DM_CustomerDS_FIRSTNAME","First Name"},
     {"DM_CustomerDS_PHONE","Phone"},

};

  public Object[][] getContents() {
    return contents;
  }
}
