/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */

//Title:        Cliffhanger Adventure Gear
//Version:      
//Copyright:    Copyright (c) 1997 Borland International, Inc.
//Author:       Application Methods, Inc.
//Description:  Cliffhanger Adventure Gear order entry system

package borland.reference.cliffhanger;

import java.awt.*;
import java.awt.event.*;
import borland.jbcl.layout.*;
import borland.jbcl.control.*;
import java.util.*;

/**
 * SplashFrame is the splash screen used at program start up while the
 * application is loading, and the database connection being established.
 * In the constructor for the Application class of the project (in this case
 * CliffhangerApplication), show this frame before instantiating any other
 * class. Once the main form of the application is shown, hide and dispose
 * the splash screen.
 */
public class SplashFrame extends DecoratedFrame {
  ImageControl imageControl1 = new ImageControl();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  LabelControl labelControl1 = new LabelControl();
  ResourceBundle res = Res.getBundle("borland.reference.cliffhanger.Res");

  public SplashFrame() {
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  /**
   * Method generated and maintained by JBuilder designer to initialize
   * control properties.
   */
  private void jbInit() throws Exception{
    this.setSize(new Dimension(200, 250));
    this.setVisible(false);
    imageControl1.setAlignment(borland.jbcl.util.Alignment.CENTER | borland.jbcl.util.Alignment.MIDDLE);
    imageControl1.setImageName(".\\graphics\\logo.gif");
    labelControl1.setAlignment(Label.CENTER);
    labelControl1.setText(res.getString("SF_Loading_"));
    this.setLayout(gridBagLayout1);
    this.add(imageControl1, new GridBagConstraints2(0, 0, 1, 1, 1.0, 1.0
            ,GridBagConstraints.NORTH, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
    this.add(labelControl1, new GridBagConstraints2(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
  }
}
